/**************************************************
 *  LCD + Sensor
 *   I2C LCD and AM2302(1Wire Serial)
 *   PIC16F18313
 *************************************************/
#include "mcc_generated_files/mcc.h"
#include "lcd_lib2.h"
// ϐ`
uint16_t Temperature, Humidity;
char DataByte[5], Flag;
char Line1[17] = "Temp = xx.x DegC";
char Line2[17] = "Humi = xx.x %RH ";
// ֐vg
void GetSensor(void);
/******************************
 * ^C}0荞ݏ֐
 * 2b
 *****************************/
void TMR0_Process(void){
    Flag = 1;
}
/********* C֐ *****************************/
void main(void)
{
    SYSTEM_Initialize();
    // ^C}0@Callback֐`
    TMR0_SetInterruptHandler(TMR0_Process);
    // 荞݋        
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    lcd_init();                             // LCD
    lcd_clear();                            // LCDS
    lcd_str("**Start Sensor**");            // JnbZ[W
    /**** C[v ******************/
    while (1)
    {
        if(Flag == 1){                      // 2b
            LED_SetHigh();                  // ڈ
            Flag = 0;
            // ZTf[^擾 2
            GetSensor();
            Humidity = (uint16_t)DataByte[0]*256 + DataByte[1];
            Temperature = (uint16_t)DataByte[2]*256 + DataByte[3]; 
            // ɕϊobt@Ɋi[
            Line1[7] = (char)(Temperature / 100) + '0';
            Temperature %= 100;
            Line1[8] = (char)(Temperature /10) + '0';
            Line1[10] = (char)(Temperature % 10) + '0';            
            Line2[7] = (char)(Humidity / 100)  + '0';
            Humidity %= 100;
            Line2[8] = (char)(Humidity / 10) + '0';
            Line2[10] = (char)(Humidity % 10) + '0'; 
            // LCDWs
            lcd_cmd(0x80);              // 1sڎw
            lcd_str(Line1);
            lcd_cmd(0xC0);              // 2sڎw
            lcd_str(Line2);
            LED_SetLow();
        }
    }
}
/*******************************************
 *  AM2320 Get Data 
 *   5Byte HumiH+HumiL+TempH+TempL+Check
 ********************************************/
void GetSensor(void){
    uint8_t i, j, pos;
    // Output StartPulse
    SDA_SetLow();    
    SDA_TRIS = 0;                           // o̓[h
    __delay_ms(2);                          // 2msec
    SDA_SetHigh();
    SDA_TRIS = 1;                           // ̓[h 
    __delay_us(150);                        // ŏ̃pXXLbv
    while(SDA_GetValue() == 1);             // High̊ԑ҂
    // Get 40bit data 5 byte
    for(j=0; j<5; j++){                     // 5oCgJԂ
        DataByte[j] = 0;                    // f[^Zbg
        pos = 0x80;                         // ŏʃrbg
        for(i=0; i<8; i++){                 // 8rbgJԂ
            while(SDA_GetValue() == 0);     // Low50usec҂
            __delay_us(40);                 // 40usecXLbv          
            if(SDA_GetValue() == 1){        // 01̔
                DataByte[j] |= pos;         // 1̏ꍇZbg
                while(SDA_GetValue() == 1); // rbgI҂  
            }
            pos >>= 1;                      // ̃rbg
         }
    }
}
